package com.cxytiandi.course1;

import java.time.Duration;
import java.time.Instant;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;

public class CompletableFutureTest {
	public static void main(String[] args) throws Exception {
		ExecutorService executor = Executors.newFixedThreadPool(5);
		
		/*Callable<String> call = new Callable<String>() {
			@Override
			public String call() throws Exception {
				Thread.sleep(1000);
				return "result";
			}
		};
		
		FutureTask<String> task = new FutureTask<>(call);
		executor.submit(task);
		
		System.out.println(task.get());*/
		
		CompletableFuture<String> f1 = CompletableFuture.supplyAsync(() -> {
			try {
				Thread.sleep(1000);
			} catch (Exception e) {
				e.printStackTrace();
			}
			return "future1";
		}, executor);
		
		//System.out.println(f1.get()); 阻塞的
		
		//非阻塞的
		/*f1.thenAccept(r -> {
			System.out.println(r);
		});
		
		f1.thenRun(() -> {
			System.out.println("任务完成之后需要通知某某");
		});
		*/
		
		/*CompletableFuture<String> f2 = f1.thenApply(new Function<String, String>() {
			@Override
			public String apply(String result) {
				return result + "第二次加工结果";
			}
		});
		System.out.println(f2.get());*/
		
		/*CompletableFuture<String> f3 = CompletableFuture.supplyAsync( () -> {
			return "猿天地";
		});
		
		CompletableFuture<String> f4 = CompletableFuture.supplyAsync( () -> {
			return "你好";
		});
		
		CompletableFuture<String> f5 = f3.thenCombine(f4, new BiFunction<String, String, String>() {
				@Override
				public String apply(String t, String u) {
					return t + u;
				}
		});
		System.out.println(f5.get());
		*/
		
		Instant statr = Instant.now();
		List<String> shops = Arrays.asList("iphone", "ipad", "mac", "air");
		List<Double> prices = new ArrayList<>();
		/*for (String shop : shops) {
			prices.add(getShopPrice(shop));
		}*/
		List<CompletableFuture<Double>> listTasks = shops.stream().map(shop -> CompletableFuture.supplyAsync(() -> {
			return getShopPrice(shop);
		},executor)).collect(Collectors.toList());
		
		prices = listTasks.stream().map(CompletableFuture::join).collect(Collectors.toList());
		
		System.out.println(prices.toString());
		System.err.println("-------");
		Instant end = Instant.now();
		System.out.println(Duration.between(statr, end).toMillis());
		executor.shutdown();
	}
	
	private static double getShopPrice(String shop) {
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return 111.1;
	}
}
